//+------------------------------------------------------------------+
//|                                               Unsmoothed_RSI.mq4 |
//|                               Copyright  2013, Gehtsoft USA LLC |
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2013, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Yellow

extern int Length=14;
extern int Price=0;      // Applied price
                         // 0 - Close
                         // 1 - Open
                         // 2 - High
                         // 3 - Low
                         // 4 - Median
                         // 5 - Typical
                         // 6 - Weighted  

double U_RSI[];
double Pos[], Neg[];

int init()
{
   IndicatorDigits(Digits);
   IndicatorBuffers(3);
   SetIndexBuffer(0,U_RSI);
   SetIndexBuffer(1,Pos);
   SetIndexBuffer(2,Neg);
   IndicatorShortName("Unsmoothed RSI 2");
   return(0);
}
int deinit() { return(0); }
int start()
{
   int counted_bars=IndicatorCounted();
      if (counted_bars<0) return(-1);
      if (counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-2);

   for (int pos=limit; pos>=0; pos--)
   {
      double Diff=iMA(NULL, 0, 1, 0, MODE_SMA, Price, pos)-iMA(NULL, 0, 1, 0, MODE_SMA, Price, pos+1);
      if (Diff>0)
            { Pos[pos]=Diff; Neg[pos]=0;     }
      else  { Pos[pos]=0;    Neg[pos]=-Diff; }
   } 
   for (pos=limit; pos>=0; pos--)
   {
      double P=iMAOnArray(Pos, 0, Length, 0, MODE_SMA, pos);
      double N=iMAOnArray(Neg, 0, Length, 0, MODE_SMA, pos);
      if (N==0)
            U_RSI[pos]=0;
      else  U_RSI[pos]=100-(100/(1+P/N));
   }  
   return(0);
}